> ## Documentation Index
> Fetch the complete documentation index at: https://docs.stigg.io/llms.txt
> Use this file to discover all available pages before exploring further.

# Update a feature

> Updates an existing feature's properties such as display name, description, and configuration.



## OpenAPI

````yaml https://app.stainless.com/api/spec/documented/stigg/openapi.documented.yml patch /api/v1/features/{id}
openapi: 3.0.0
info:
  title: Stigg API
  description: Stigg API documentation
  version: 7.93.1
  contact: {}
servers:
  - url: https://api.stigg.io
    description: Production
security:
  - ApiKeyAuth: []
tags:
  - name: Customers
    description: Operations related to customers
  - name: Subscriptions
    description: Operations related to subscriptions
  - name: Coupons
    description: Operations related to coupons
  - name: Bulk Import
    description: Operations related to import of customers and subscriptions
  - name: Usage
    description: Operations related to usage & metering
  - name: Promotional Entitlements
    description: Operations related to promotional entitlements
  - name: Products
    description: Operations related to products
  - name: Features
    description: Operations related to features
  - name: Addons
    description: Operations related to addons
  - name: Plans
    description: Operations related to plans
  - name: Credit grants
    description: Operations related to credit grants
  - name: Credit ledger
    description: Operations related to credit ledger
  - name: Custom currencies
    description: Operations related to custom currencies
paths:
  /api/v1/features/{id}:
    patch:
      tags:
        - Features
      summary: Update a feature
      description: >-
        Updates an existing feature's properties such as display name,
        description, and configuration.
      operationId: FeatureController_updateFeature
      parameters:
        - name: id
          required: true
          in: path
          description: The unique identifier of the entity
          schema:
            minLength: 1
            maxLength: 255
            type: string
        - name: X-ACCOUNT-ID
          in: header
          description: >-
            Account ID — optional when authenticating with a user JWT (Bearer
            token); falls back to the user's first membership. Ignored for
            API-key auth.
          required: false
          schema:
            type: string
        - name: X-ENVIRONMENT-ID
          in: header
          description: >-
            Environment ID — required when authenticating with a user JWT
            (Bearer token) on environment-scoped endpoints. Ignored for API-key
            auth (env is intrinsic to the key).
          required: false
          schema:
            type: string
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/UpdateFeatureRequestDto'
      responses:
        '200':
          description: The updated feature object.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/FeatureResponseDto'
              examples:
                default:
                  value:
                    data:
                      id: feature-api-calls
                      displayName: API Calls
                      description: Number of API calls allowed per month
                      featureType: NUMBER
                      meterType: INCREMENTAL
                      featureUnits: call
                      featureUnitsPlural: calls
                      featureStatus: ACTIVE
                      unitTransformation: null
                      enumConfiguration: null
                      metadata: {}
                      createdAt: '2025-10-26T10:00:00.000Z'
                      updatedAt: '2025-10-26T10:00:00.000Z'
        '400':
          description: bad request.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/BadInputErrorResponseDto'
        '401':
          description: User is not authenticated.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/UnauthenticatedErrorResponseDto'
        '403':
          description: User is not allowed to access this resource.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ForbiddenErrorResponseDto'
        '404':
          description: Feature not found.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/NotFoundErrorResponseDto'
        '429':
          description: Too many requests.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/TooManyRequestsErrorResponseDto'
      x-codeSamples:
        - lang: JavaScript
          source: |-
            import Stigg from '@stigg/typescript';

            const client = new Stigg({
              apiKey: process.env['STIGG_API_KEY'], // This is the default and can be omitted
            });

            const feature = await client.v1.features.updateFeature('x');

            console.log(feature.data);
        - lang: Python
          source: |-
            import os
            from stigg import Stigg

            client = Stigg(
                api_key=os.environ.get("STIGG_API_KEY"),  # This is the default and can be omitted
            )
            feature = client.v1.features.update_feature(
                id="x",
            )
            print(feature.data)
        - lang: Go
          source: "package main\n\nimport (\n\t\"context\"\n\t\"fmt\"\n\n\t\"github.com/stiggio/stigg-go\"\n\t\"github.com/stiggio/stigg-go/option\"\n)\n\nfunc main() {\n\tclient := stigg.NewClient(\n\t\toption.WithAPIKey(\"My API Key\"),\n\t)\n\tfeature, err := client.V1.Features.UpdateFeature(\n\t\tcontext.TODO(),\n\t\t\"x\",\n\t\tstigg.V1FeatureUpdateFeatureParams{},\n\t)\n\tif err != nil {\n\t\tpanic(err.Error())\n\t}\n\tfmt.Printf(\"%+v\\n\", feature.Data)\n}\n"
        - lang: Java
          source: |-
            package io.stigg.example;

            import io.stigg.client.StiggClient;
            import io.stigg.client.okhttp.StiggOkHttpClient;
            import io.stigg.models.v1.features.Feature;
            import io.stigg.models.v1.features.FeatureUpdateFeatureParams;

            public final class Main {
                private Main() {}

                public static void main(String[] args) {
                    StiggClient client = StiggOkHttpClient.fromEnv();

                    Feature feature = client.v1().features().updateFeature("x");
                }
            }
        - lang: Ruby
          source: |-
            require "stigg"

            stigg = Stigg::Client.new(api_key: "My API Key")

            feature = stigg.v1.features.update_feature("x")

            puts(feature)
        - lang: C#
          source: |-
            using System;
            using Stigg.Client;
            using Stigg.Client.Models.V1.Features;

            StiggClient client = new();

            FeatureUpdateFeatureParams parameters = new() { ID = "x" };

            var feature = await client.V1.Features.UpdateFeature(parameters);

            Console.WriteLine(feature);
        - lang: CLI
          source: |-
            stigg v1:features update-feature \
              --api-key 'My API Key' \
              --id x
components:
  schemas:
    UpdateFeatureRequestDto:
      type: object
      properties:
        displayName:
          type: string
          maxLength: 255
          description: The display name for the feature
        description:
          type: string
          maxLength: 255
          description: The description for the feature
        featureUnits:
          type: string
          maxLength: 255
          description: The units for the feature
        featureUnitsPlural:
          type: string
          maxLength: 255
          description: The plural units for the feature
        metadata:
          type: object
          additionalProperties:
            type: string
          description: The additional metadata for the feature
        unitTransformation:
          type: object
          properties:
            divide:
              type: integer
              description: Divide usage by this number
            round:
              default: UP
              type: string
              enum:
                - UP
                - DOWN
              description: After division, either round the result up or down
            featureUnits:
              type: string
              maxLength: 255
              description: Singular feature units after the transformation
            featureUnitsPlural:
              type: string
              maxLength: 255
              description: Plural feature units after the transformation
          required:
            - divide
          additionalProperties: false
          nullable: true
          description: Unit transformation to be applied to the reported usage
        enumConfiguration:
          type: array
          items:
            type: object
            properties:
              value:
                type: string
                maxLength: 64
                description: The unique value identifier for the enum configuration entity
              displayName:
                type: string
                maxLength: 64
                description: The display name for the enum configuration entity
            required:
              - value
              - displayName
            additionalProperties: false
          minItems: 1
          maxItems: 255
          description: The configuration data for the feature
        meter:
          type: object
          properties:
            filters:
              type: array
              items:
                type: object
                properties:
                  conditions:
                    type: array
                    items:
                      type: object
                      properties:
                        operation:
                          type: string
                          enum:
                            - EQUALS
                            - NOT_EQUALS
                            - GREATER_THAN
                            - GREATER_THAN_OR_EQUAL
                            - LESS_THAN
                            - LESS_THAN_OR_EQUAL
                            - IS_NULL
                            - IS_NOT_NULL
                            - CONTAINS
                            - STARTS_WITH
                            - ENDS_WITH
                            - IN
                        field:
                          type: string
                          maxLength: 255
                          description: Condition field name
                        value:
                          type: string
                          maxLength: 255
                          description: Condition value
                        values:
                          type: array
                          items:
                            type: string
                            maxLength: 255
                            description: Condition values
                      required:
                        - operation
                        - field
                      additionalProperties: false
                    minItems: 1
                required:
                  - conditions
                additionalProperties: false
              minItems: 1
            aggregation:
              type: object
              properties:
                function:
                  type: string
                  enum:
                    - SUM
                    - MAX
                    - MIN
                    - AVG
                    - COUNT
                    - UNIQUE
                field:
                  type: string
                  maxLength: 255
                  description: Aggregation field name
              required:
                - function
              additionalProperties: false
          required:
            - filters
            - aggregation
          additionalProperties: false
      additionalProperties: false
      title: UpdateFeatureRequest
      description: Partially update an existing feature. Only provided fields are updated.
    FeatureResponseDto:
      type: object
      properties:
        data:
          type: object
          properties:
            id:
              type: string
              maxLength: 255
              description: The unique identifier for the feature
            displayName:
              type: string
              maxLength: 255
              description: The display name for the feature
            description:
              type: string
              maxLength: 255
              description: The description for the feature
              nullable: true
            featureType:
              type: string
              enum:
                - BOOLEAN
                - NUMBER
                - ENUM
              description: The type of the feature
            meterType:
              type: string
              enum:
                - None
                - FLUCTUATING
                - INCREMENTAL
              description: The meter type for the feature
            featureUnits:
              type: string
              maxLength: 255
              description: The units for the feature
              nullable: true
            featureUnitsPlural:
              type: string
              maxLength: 255
              description: The plural units for the feature
              nullable: true
            featureStatus:
              type: string
              enum:
                - NEW
                - SUSPENDED
                - ACTIVE
              description: The status of the feature
            unitTransformation:
              type: object
              properties:
                divide:
                  type: number
                  description: Divide usage by this number
                round:
                  type: string
                  enum:
                    - UP
                    - DOWN
                  description: After division, either round the result up or down
                featureUnits:
                  type: string
                  maxLength: 255
                  description: Singular feature units after the transformation
                  nullable: true
                featureUnitsPlural:
                  type: string
                  maxLength: 255
                  description: Plural feature units after the transformation
                  nullable: true
              required:
                - divide
                - round
                - featureUnits
                - featureUnitsPlural
              title: UnitTransformation
              description: Unit transformation to be applied to the reported usage
              nullable: true
            enumConfiguration:
              type: array
              items:
                type: object
                properties:
                  value:
                    type: string
                    maxLength: 255
                    description: >-
                      The unique value identifier for the enum configuration
                      entity
                  displayName:
                    type: string
                    maxLength: 255
                    description: The display name for the enum configuration entity
                required:
                  - value
                  - displayName
              nullable: true
              description: The configuration data for the feature
            metadata:
              type: object
              additionalProperties:
                type: string
              description: The additional metadata for the feature
            createdAt:
              type: string
              format: date-time
              description: Timestamp of when the record was created
            updatedAt:
              type: string
              format: date-time
              description: Timestamp of when the record was last updated
          required:
            - id
            - displayName
            - description
            - featureType
            - meterType
            - featureUnits
            - featureUnitsPlural
            - featureStatus
            - unitTransformation
            - enumConfiguration
            - metadata
            - createdAt
            - updatedAt
          title: Feature
          description: Feature configuration object
      required:
        - data
      title: Response
      description: Response object
    BadInputErrorResponseDto:
      type: object
      properties:
        message:
          type: string
        code:
          type: string
          enum:
            - BadUserInput
            - DuplicateIntegrationNotAllowed
            - EntityIsArchivedError
            - IntegrityViolation
            - FreePlanCantHaveCompatiblePackageGroupError
            - SubscriptionMustHaveSinglePlanError
            - AddonIsCompatibleWithPlan
            - AddonIsCompatibleWithGroup
            - DuplicateAddonProvisionedError
            - ScheduledMigrationAlreadyExistsError
            - SubscriptionAlreadyOnLatestPlan
            - EntityIdDifferentFromRefIdError
            - UnsupportedFeatureType
            - UnsupportedVendorIdentifier
            - UnsupportedSubscriptionScheduleType
            - InvalidEntitlementResetPeriod
            - IncompatibleSubscriptionAddon
            - UnPublishedPackage
            - MeteringNotAvailableForFeatureType
            - AuthCustomerMismatch
            - AuthCustomerReadonly
            - FetchAllCountriesPricesNotAllowed
            - MemberInvitationError
            - PlansCircularDependencyError
            - NoFeatureEntitlementInSubscription
            - CheckoutIsNotSupported
            - UnsupportedParameter
            - PricingModelNotSupportedByBillingIntegration
            - BillingIntegrationMissing
            - BillingIntegrationAlreadyExistsError
            - InvalidMemberDelete
            - PackageAlreadyPublished
            - DraftPlanCantBeArchived
            - DraftAddonCantBeArchived
            - PlanWithChildCantBeDeleted
            - PlanCannotBePublishWhenBasePlanIsDraft
            - PlanCannotBePublishWhenCompatibleAddonIsDraft
            - PlanIsUsedAsDefaultStartPlan
            - PlanIsUsedAsDowngradePlan
            - InvalidAddressError
            - InvalidQuantity
            - BillingPeriodMissingError
            - DowngradeBillingPeriodNotSupportedError
            - CustomerAlreadyUsesCouponError
            - CustomerAlreadyHaveCustomerCoupon
            - SubscriptionAlreadyCanceledOrExpired
            - TrialMustBeCancelledImmediately
            - SubscriptionDoesNotHaveBillingPeriod
            - InvalidCancellationDate
            - FailedToImportCustomer
            - FailedToImportSubscriptions
            - PackagePricingTypeNotSet
            - InvalidSubscriptionStatus
            - InvalidArgumentError
            - EditAllowedOnDraftPackageOnlyError
            - ResyncAlreadyInProgress
            - ArchivedCouponCantBeApplied
            - ImportAlreadyInProgress
            - AddonHasToHavePriceError
            - SelectedBillingModelDoesntMatchImportedItemError
            - CannotArchiveProductError
            - CannotUnarchiveProductError
            - CannotDeleteCustomerError
            - CannotRemovePaymentMethodFromCustomerError
            - CannotDeleteFeatureError
            - CannotArchiveFeatureError
            - InvalidUpdatePriceUnitAmountError
            - ExperimentAlreadyRunning
            - ExperimentStatusError
            - OperationNotAllowedDuringInProgressExperiment
            - EntitlementsMustBelongToSamePackage
            - CanNotUpdateEntitlementsFeatureGroup
            - MeterMustBeAssociatedToMeteredFeature
            - CannotEditPackageInNonDraftMode
            - CannotAddOverrideEntitlementToPlan
            - MissingEntityIdError
            - NoProductsAvailable
            - PromotionCodeNotForCustomer
            - PromotionCodeNotActive
            - PromotionCodeMaxRedemptionsReached
            - PromotionCodeMinimumAmountNotReached
            - PromotionCodeCustomerNotFirstPurchase
            - AddonWithDraftCannotBeDeletedError
            - CannotReportUsageForEntitlementWithMeterError
            - RecalculateEntitlementsError
            - ImportSubscriptionsBulkError
            - InvalidMetadataError
            - CannotUpsertToPackageThatHasDraft
            - IntegrationValidationError
            - AwsMarketplaceIntegrationValidationError
            - AwsMarketplaceIntegrationError
            - DataExportIntegrationError
            - HubspotIntegrationError
            - DuplicateProductValidationError
            - AmountTooLarge
            - CustomerHasNoEmailAddress
            - MergeEnvironmentValidationError
            - EntitlementLimitExceededError
            - EntitlementUsageOutOfRangeError
            - UsageMeasurementDiffOutOfRangeError
            - AddonQuantityExceedsLimitError
            - AddonDependencyMissingError
            - PackageGroupMinItemsError
            - CannotUpdateUnitTransformationError
            - SingleSubscriptionCantBeAutoCancellationTargetError
            - MultiSubscriptionCantBeAutoCancellationSourceError
            - ChangingPayingCustomerIsNotSupportedError
            - RequiredSsoAuthenticationError
            - InvalidDoggoSignatureError
            - InvalidReceivedSignatureError
            - CannotDeleteDefaultIntegration
            - CannotChangeBillingIntegration
            - FailedToResolveBillingIntegration
            - WorkflowTriggerNotFound
            - DeprecatedEstimateSubscriptionError
            - FeatureConfigurationExceededLimitError
            - FeatureNotBelongToFeatureGroupError
            - FeatureGroupMissingFeaturesError
            - VersionExceedsMaxValueError
            - CannotUpdateExpireAtForExpiredCreditGrantError
            - ExpireAtMustBeLaterThanEffectiveAtError
            - OfferAlreadyExists
            - DraftAlreadyExists
            - CreditGrantAlreadyVoided
            - CreditGrantCannotBeVoided
            - InvalidTaxId
            - ObjectAlreadyBeingUsedByAnotherRequestError
            - TooManySubscriptionsPerCustomer
            - TooManyCustomCurrencies
            - StripeError
            - SchedulingAtEndOfBillingPeriod
            - ApiKeyExpired
            - ApiKeyHasExpiry
          nullable: true
      required:
        - message
        - code
    UnauthenticatedErrorResponseDto:
      type: object
      properties:
        message:
          type: string
        code:
          type: string
          enum:
            - Unauthenticated
          nullable: true
      required:
        - message
        - code
    ForbiddenErrorResponseDto:
      type: object
      properties:
        message:
          type: string
        code:
          type: string
          enum:
            - IdentityForbidden
            - AccessDeniedError
            - NoFeatureEntitlementError
            - GovernanceNotEnabled
          nullable: true
      required:
        - message
        - code
    NotFoundErrorResponseDto:
      type: object
      properties:
        message:
          type: string
        code:
          type: string
          enum:
            - CustomerNotFound
            - CustomCurrencyNotFound
            - CreditGrantNotFound
            - MemberNotFound
            - PackageGroupNotFound
            - AddonNotFound
            - AddonsNotFound
            - EnvironmentMissing
            - IntegrationNotFound
            - VendorIsNotSupported
            - CouponNotFound
            - FutureUpdateNotFound
            - CustomerNoBillingId
            - SubscriptionNoBillingId
            - StripeCustomerIsDeleted
            - InitStripePaymentMethodError
            - PreparePaymentMethodFormError
            - AccountNotFoundError
            - ExperimentNotFoundError
            - NoDraftOfferFound
            - PromotionCodeNotFound
            - FailedToCreateCheckoutSessionError
            - PaymentMethodNotFoundError
            - ProductNotFoundError
            - ProductNotPublishedError
            - MissingBillingInvoiceError
            - BillingInvoiceStatusError
            - FeatureGroupNotFoundError
            - CannotArchiveFeatureGroupError
            - OfferNotFound
            - CustomerResourceNotFound
            - FeatureNotFound
            - PriceNotFound
            - NoActiveSubscriptionForCustomer
            - PlanNotFound
            - PromotionalEntitlementNotFoundError
            - SubscriptionNotFound
            - ApiKeyNotFound
          nullable: true
      required:
        - message
        - code
    TooManyRequestsErrorResponseDto:
      type: object
      properties:
        message:
          type: string
        code:
          type: string
          enum:
            - RateLimitExceeded
          nullable: true
      required:
        - message
        - code
  securitySchemes:
    ApiKeyAuth:
      type: apiKey
      in: header
      name: X-API-KEY
      description: Server API Key

````